from config import PROJECTNAME, META_TYPE, PORTAL_TYPE, TITLE, DESCRIPTION
from Products.CMFCore import CMFCorePermissions
from Products.CMFPlone.LargePloneFolder import LargePloneFolder
from AccessControl import ClassSecurityInfo

"""
Folder for Images in a photo album format.   http://www.zope.org/Members/bowerymarc

"""

factory_type_information =      ({'id':PORTAL_TYPE,
                                  'meta_type':META_TYPE,
                                  'portal_type':PORTAL_TYPE,
                                  'factory':'addPhotoAlbum',
                                  'icon' : 'photoalbum.gif',
                                  'product' : PROJECTNAME,
                                  'filter_content_types' : 1,
                                  'allowed_content_types': ('Image', 'File', 'Link',  PORTAL_TYPE, 'Photo'),
                                  'title' : TITLE,
                                  'description': DESCRIPTION,
                                  'immediate_view' : 'photoalbum_view',
                                  'actions'        :
                                ( { 'id'            : 'view'
                                  , 'name'          : 'Browse'
                                  , 'action'        : 'string:${folder_url}/photoalbum_view'
                                  , 'permissions'   :
                                     (CMFCorePermissions.View,)
                                  , 'category'      : 'folder'
                                  }
                                 ,{ 'id'            : 'viewlist'
                                  , 'name'          : 'List'
                                  , 'action'        : 'string:${folder_url}/photoalbum_listview'
                                  , 'permissions'   :
                                     (CMFCorePermissions.View,)
                                  , 'category'      : 'folder'
                                  }
                                 ,{ 'id'            : 'viewone'
                                  , 'name'          : 'View'
                                  , 'action'        : 'string:${folder_url}/photoalbum_singleview'
                                  , 'permissions'   :
                                     (CMFCorePermissions.View,)
                                  , 'category'      : 'folder'
                                  }
                                , { 'id'            : 'local_roles'
                                  , 'name'          : 'Local Roles'
                                  , 'action'        : 'string:${folder_url}/folder_localrole_form'
                                  , 'permissions'   :
                                     (CMFCorePermissions.ManageProperties,)
                                  , 'category'      : 'folder'
                                  }
                                , { 'id'            : 'edit'
                                  , 'name'          : 'Edit'
                                  , 'action'        : 'string:${folder_url}/folder_edit_form'
                                  , 'permissions'   :
                                     (CMFCorePermissions.ManageProperties,)
                                  , 'category'      : 'folder'
                                  }
                               , { 'id'            : 'metadata'
                                 , 'name'          : 'Metadata'
                                 , 'action': 'string:${object_url}/metadata_edit_form'
                                 , 'permissions'   : (CMFCorePermissions.ManageProperties,)
                                 }
                                 #we need this one due to inheriting from PloneFolder
                                , { 'id'            : 'folderlisting'
                                  , 'name'          : 'Folder Listing'
                                  , 'action'        : 'string:${folder_url}/photoalbum_view'
                                  , 'permissions'   :
                                     (CMFCorePermissions.View,)
                                  , 'category'      : 'folder'
                                  , 'visible'       : 0
                                  }
                                ),
                          
                                  },
                                )


class PhotoAlbum(LargePloneFolder):
    """
Photo Album folder.  Deals with Files that might be movies, and tolerates Links.
    """

    meta_type = META_TYPE
    portal_type = PORTAL_TYPE

    security = ClassSecurityInfo()

    __implements__ = LargePloneFolder.__implements__


    def __init__(self, id, title=''):
        LargePloneFolder.__init__(self, id, title)
        self.id=id
        self.title=title

    manage_renameObject = LargePloneFolder.inheritedAttribute('manage_renameObject')
    manage_delObjects = LargePloneFolder.inheritedAttribute('manage_delObjects')
    
    # grabbed from LargePloneFolder
    __len__ = LargePloneFolder.__len__
    


def addPhotoAlbum(self, id, title='', description='', REQUEST=None):
    """ add a BTree-backed Photo Album Folder """
    obj = PhotoAlbum(id, title=title)
    obj.setDescription(description)
    self._setObject(id, obj)
    if REQUEST is not None:
        REQUEST['RESPONSE'].redirect( sf.absolute_url() + '/manage_main' )

